			     RELEASE NOTES
	       OpenNT Commands And Utilities Release 1.1

CONTENTS
 * About the 30-Day Demo
 * Enabling the OpenNT Commands & Utilities
 * New In This Release
 * Installation
   - For All Systems
   - For X86 Systems Running Windows NT 4.0
 * Running Win32 Programs
 * Reading the On-Line Docs
 * #! and Pathnames
 * Documentation Corrections
 * The Telnet Demo
 * Registry Entries
 * Comments, Please
 * Known Problems

ABOUT THE 30-DAY DEMO:

If you got this version of the OpenNT Commands & Utilities from 
our web site, YOU MUST ENABLE IT AFTER INSTALLATION WITH YOUR KEY.
If you do not, OpenNT will not run correctly. See next section for
instructions. The trial period expires 30 days after you receive your key.
You will still be able to use the Uninstall command to clear the
installation, and Setup to restore your original POSIX subsystem.

If you have ordered your copy of the Commands & Utilities but it has not
arrived by the time your demo expires, please contact sales@softway.com
for help.

ENABLING THE OPENNT COMMANDS & UTILITIES:

After you have installed the OpenNT Commands & Utilities you obtained
from our website, you must enable the system using the key that has been
e-mailed to you. You do *not* have to enable the system if you purchased
it; only the 30-day demo version must be enabled.

To enable the demo system:

1. Just like the installation procedure, you must have Administrator
   privileges.

2. Open a DOS console box (CMD.EXE) and cd to the setup directory.

3. Run the OPENNTREG program found there. In this example, 12345678
   represents the key we e-mailed to you:

   OPENNTREG 12345678

   Once the program has succeeded, the system responds:

   The OpenNT Commands & Utilities have been successfully registered.

NEW IN RELEASE 1.1:

 * You can now run Win32 programs from the OpenNT shells!

 * lp      The lp utility has been improved, and will send
	   files to the printer.  This version is a shell
	   script.

 * ls -l   is substantially faster.


This release contains new utilities, including:

   ctags    Create a tags file

   expand   Convert tabs into spaces

   flip     Convert text files between MS-DOS and POSIX
            formats, which replaces stripcr

   ksh      A KornShell

   man      Read on-line documentation.  (This is traditional
	    UNIX man pages, distinct from the PDF documentation.)

   merge    Three-way file merge

   ntpath2posix, posixpath2nt
	    Convert pathnames between Windows NT format and POSIX
	    format

   split    Split files

   tar      When invoked as tar, the pax command behaves as tar.
   This
	    release provides a copy of pax under the name tar.

   unifdef  Preprocess C source to expand all #ifdef blocks

   unexpand Convert spaces into tabs.

   virec    Recover lost files if vi session is suddenly terminated.


INSTALLATION:

For all systems:

Permissions on the tmp directory under the OpenNT installation
root (normally the directory //C/OpenNT) should be set so
everyone has full read, write, execute, and delete permissions
(Full Control in Windows NT terms).  You may want to ensure this
by setting it manually from the Windows NT universe:

 1. As Administrator, start the File Manager

 2. Select the directory //C/OpenNT/tmp.  (Substitute the actual
    location, if necessary.)

 3. Under the Security Menu, select Permissions.

 4. Give Full Control to the group Everyone.  You may want to
    assign Full Control to other groups as well, but you should
    give it to Everyone.


For X86 systems running Windows NT 4.0:

Although the OpenNT program group is meant to be a Common group,
it is installed as a Personal group.  This is due to a version
mismatch in Installshield, and it only happens in Intel systems
running Windows NT 4.0.

To fix it:

 1. In Explorer, open the menu to the OpenNT group in
    <systemroot>/WINNT40/Pro9files/<installing user>/Start
    Menu/Programs

 2. Using the left mouse button, click and drag the group to
    Profiles/All Users/Start Menu/Programs

 3. Now change the permissions on the group so all users have
    Full Control.  Select the OpenNT group.

 4. From the File menu, choose Properties.

 5. Under the Security Tab, select Permissions.

 6. Add group "Everyone" with "Full Control".

RUNNING WIN32 PROGRAMS:

The OpenNT subsystem extends the POSIX subsystem so you can run
Win32 CUI (command-line) and Win32 GUI programs.  For example,
from the OpenNT shells you can run programs such as ATTRIB.EXE,
CACLS.EXE and REGEDT32.EXE. You can also redirect the output of
these programs to files and redirect the input from files.  Win32
programs *may* generate fake error messages, though; see "Win32
Exit Status" later in this section.

The simplest way to add the Win32 commands to your environment is
to add the appropriate directories to your PATH. For example:

     $ PATH="$PATH://C/WINNT35/system32"

Note that the pathname is added in the POSIX filename format, not
the Win32 format.

The program naming conventions differ between the POSIX subsystem
and the Win32 subsystem.  The POSIX pathnames are case-sensitive
while the Win32 names are not; most Win32 programs have names
ending in .EXE or
.exe.

For frequently-used commands, you can  handle this with aliases
or links, depending upon your needs and your system
administration environment.

Aliases have the advantage of easy customization; anyone can set
up aliases, even without Administrator privileges.  If there are
only one or two Win32 commands you expect to use, you won't even
need to change your PATH.

For example:

     $ alias attrib="//C/WINNT35/system32/ATTRIB.EXE"

     $ alias cacls="//C/WINNT35/system32/CACLS.EXE"

runs the ATTRIB.EXE program when you give the command attrib, and
runs the CACLS.EXE program when you give the command cacls.
Links have the advantage of being more like the traditional UNIX
environment.

For example:

     $ cd //C/WINNT35/system32

     $ ln PING.EXE ping

Assuming your PATH includes //C/WINNT35/system32, you can run the
program PING.EXE with the command ping.

Links have several disadvantages: your Windows NT system drive
must be an NTFS partition, and you may need Administrator
privileges.  Experienced users also know that links can get out
of hand easily and lead to an administrative nightmare.

Because you can run CMD.EXE (the Windows NT "DOS" command
processor), in this way you can also run CMD.EXE built-in
commands.  Again assuming your PATH has been set up to include
the correct paths, here's how you could set up your OpenNT
environment to give you the dir command for directory listings:

     $ alias dir='CMD.EXE /c "dir /on"'
     
     $ dir
     Volume in drive C has no label.
     Volume Serial Number is 14CC-6DB9
     Directory of C:\USERS\stephe
     
     08/12/96  12:12p        <DIR>          .
     08/12/96  12:12p        <DIR>          ..
     08/10/96  05:46p                   170 .profile
     07/10/96  05:41p                   110 able
         ....
     08/02/96  05:20p        <DIR>          test
     07/10/96  01:33p                 6,656 REPORT.DOC
     
              48 File(s)        625,581 bytes
                           358,595,584 bytes free


Win32 Exit Status:

Even when it runs successfully and exits, a Win32 program may
"tell" the OpenNT shell program that it failed.  The shell will
then give you an error message (typically something like "Signal
received"), but you can ignore it.  (If your Win32 application
failed, you already know.)

When a program finishes, it passes a number back to the shell.
POSIX programs use this number (the exit status) to indicate
whether the program ran successfully or, if an error occurred,
what type of error it was.  The format of an exit status for a
Win32 program is very different.  The shell tries to interpret
the Win32 exit status as a POSIX value.  The Win32 number may be
the same as the number of a POSIX error -- so the shell tells you
about it.

READING THE ON-LINE DOCS:

The documentation for the OpenNT Commands and Utilities is
provided in Adobe's Portable Document Format (PDF), which
requires the Acrobat PDF reader.  If you don't already have the
Acrobat reader, one has been provided on the distribution CD. It
is a self-extracting archive for Intel architectures.  If you are
working on another architecture, you will need to experiment.
You may also want to check the Adobe Web page for information on
versions of Acrobat for your architecture:

    http://www.adobe.com/

The User's Guide contains some information on customizing the
Acrobat display.


#! AND PATHNAMES:

The OpenNT shells understand the traditional #!  notation -- that
is, you can invoke a program to read a script by starting the
script with the line

    #! <command>

Where <command> is a command to read and execute a script (often
/bin/sh, but not necessarily; for example, it could be /bin/awk
-f or /bin/sed -f).  If the command starts with /bin, the shells
prepend the install root of the OpenNT directory; if the command
is anything else, it is treated as an absolute pathname.

For example, #!  /bin/sh looks for sh in //C/OpenNT/bin (assuming
you've installed OpenNT in the directory //C/OpenNT).  This
behavior means you don't have to change scripts brought over from
traditional UNIX environments.


TELNET DEMO:

   This release of the OpenNT Commands and Utilities contains a
   demonstration version of the OpenNT Telnet Server.  You can
   install it on your system and try it for 14 days.

   If it meets your needs, contact Softway Systems to purchase
   the enabling key to transform it from a demonstration to
   production software.  You can reach Softway Systems at:

   Phone:    (415) 896-0708
   FAX:      (415) 896-0709
   E-mail:   sales@softway.com

   If you are in North America, you can call 1-800-GET-UNIX.

DOCUMENTATION CORRECTIONS:

 * Please see the additional Installation instructions given in
   this file

 * In the PDF version of the User's Guide, the page numbers that
   appear after index entries are links to the item being
   referenced.  If you click on the page number, Acrobat will
   display that page.

 * The entries in the table of contents are also links.

 * Our vi editor is currently a port of the Elvis editor.  If you
   are unfamiliar with vi, we have shipped the Elvis manual,
   which provides complete documentation about the editing
   features and functions.  (It also includes considerable extra
   material on porting elvis to other systems.  These sections
   are not relevant to the use of the editor.) This documentation
   appears in the OpenNT/pubs directory as elvis.pdf.

 * The User's Guide doesn't mention that the Install program will
   create the directory /OpenNT/usr/spool/mail

REGISTRY ENTRIES:

 The install program installs the following entries in the
 registry:

    HKEY_LOCAL_MACHINE\SOFTWARE\Softway Systems
    HKEY_LOCAL_MACHINE\SOFTWARE\Softway Systems\OpenNT
    HKEY_LOCAL_MACHINE\SOFTWARE\Softway Systems\OpenNT\CU
    HKEY_LOCAL_MACHINE\SOFTWARE\Softway Systems\OpenNT\_CS_PATH
    HKEY_LOCAL_MACHINE\SOFTWARE\Softway Systems\OpenNT\InstallRoot
    HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment\_POSIX_TERM
    HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment\OpenNT_ROOT


COMMENTS, PLEASE:

As hard as we have tried to provide a complete product, we expect
you will uncover problems that we have not yet discovered.  We
also encourage comments and suggestions.  (For example, we are
shipping most of the product documentation as PDF files.  We
believe this is a good model for reference documentation.  Please
let us know what you think.) To send comments, suggestions,
questions, or problems about the OpenNT Commands and Utilities,
Release 1.1 please send e-mail to: support@softway.com or
comments@softway.com whichever is appropriate.

Please include your name, a phone number where you can be
reached, and a return e-mail address if it is not the same as
that from which you sent the e-mail, along with your comments and
problem reports.

KNOWN PROBLEMS:

 * ls: the following options were changed in ls in this release,
   but the docs and the usage message were not updated to reflect
   it:
    -A behaves as it should.
    -L is accepted but does nothing
    -g prints a long listing but the owner isn't printed
    -n prints a long listing but prints the user ID and group ID numbers
       instead of the user and group names
    -o prints a long listing but the group isn't printed
    -T was removed.

--------------3CC145F72CA3--


